%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.1, (the "License"); you may not use this file except in
%% compliance with the License. You should have received a copy of the
%% Erlang Public License along with this software. If not, it can be
%% retrieved via the world wide web at http://www.erlang.org/.
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Initial Developer of the Original Code is Ericsson Utvecklings AB.
%% Portions created by Ericsson are Copyright 1999, Ericsson Utvecklings
%% AB. All Rights Reserved.''
%% 
%%     $Id$
%%
%% @reference See The MD5 Message Digest Algorithm (RFC 1321) for more
%% information about MD5.

-module(erl.util.crypt.md5).

-export([digest/1, final/1, init/0, update/2]).


%% @spec (io_list() | binary()) -> Digest
%%    Digest = binary()
%%    io_list() = [integer()|binary()|io_list()]
%% @doc Computes an MD5 message digest from <code>Data</code>, where the
%% length of the digest is 128 bits (16 bytes). <code>Data</code> is a
%% binary or a list of small integers and binaries.

digest(Data) ->
    erl.util.crypt.md5:digest(Data).		% Built-in function


%% @spec (binary()) -> Digest
%%    Digest = binary()
%% @doc Finishes the update of an MD5 Context and returns the final
%% MD5 message digest.

final(Context) ->
    erl.util.crypt.md5:final(Context).		% Built-in function


%% @spec () -> binary()
%% @doc Creates an MD5 context. The context is used in subsequent calls
%% to {@link update/2}.

init() ->
    erl.util.crypt.md5:init().		% Built-in function


%% @spec (binary(), io_list() | binary()) -> Context
%% @doc Updates an MD5 Context with <code>Data</code>, and returns a new
%% context.

update(Context, Data) ->
    erl.util.crypt.md5:update(Context, Data).		% Built-in function
